import adafruit_ulp_blink
import time
import memorymap
import struct
import alarm
import board

rtc_ctl = memorymap.AddressRange(start=0x60008000, length=0x800)

def print_regs():
    print("COCPU_INT_ST", hex(struct.unpack("I", rtc_ctl[0x0F0:0x0F4])[0]))
    print("TIMER_REG", hex(struct.unpack("I", rtc_ctl[0x0FC:0x100])[0]))
    print("CP_CTRL", hex(struct.unpack("I", rtc_ctl[0x100:0x104])[0]))
    print("COCPU_CTRL", hex(struct.unpack("I", rtc_ctl[0x104:0x108])[0]))

    print("TOUCH_PAD15", hex(struct.unpack("I", rtc_ctl[0x4c0:0x4c4])[0]))
    print("RTC_GPIO_OUT", hex(struct.unpack("I", rtc_ctl[0x400:0x404])[0]))
    print("RTC_GPIO_EN", hex(struct.unpack("I", rtc_ctl[0x40c:0x410])[0]))
    print("RTC_IO_DATE", hex(struct.unpack("I", rtc_ctl[0x5fc:0x600])[0]))

print("sleeping")
time.sleep(1)
print("awake")
print_regs()

b = adafruit_ulp_blink.Blink(led_pin=board.LED_YELLOW, delay=1000)
for i in range(5):
    time.sleep(1)
    b.delay //= 2
    print_regs()

t = alarm.time.TimeAlarm(monotonic_time=time.monotonic() + 5)
alarm.exit_and_deep_sleep_until_alarms(t)
